#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "xml_trace_reason4xi.py">
#<abstract4xi abstract = "reasons tracing and produces XML"/>
#<refer4xi reference = "yourDragonXi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "Filtered information"/>   
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'xml_trace_reason4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    from time import localtime, strftime         
except:
    pass
         
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    pass
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import Print4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

        
# -------------------------------------------------------------------------------------------------
# xml_trace_reason4xi                            
# -------------------------------------------------------------------------------------------------    
def xml_trace_reason4xi (xml_trace_reason4xi_param1, xml_trace_reason4xi_param2 = 
    {'file_path4xi': '..\\..\\xml\\reason-default4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations active.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ReasonDragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}):
    
    
    '''
    xml_trace_reason4xi reasons traced knowledgebase producing XML
    
    '''       
    # ---------------------------------------------------------------------------------------------
    # START 
    # ---------------------------------------------------------------------------------------------     
    t2xi = xml_trace_reason4xi_param1                       # pointer to Print4Xi object, mandatory
    c2xi = xml_trace_reason4xi_param2                       # context, optional
    
    keys2context = c2xi.keys()
    
    # ---------------------------------------------------------------------------------------------
    # DEBUG
    # ---------------------------------------------------------------------------------------------     
    if 'debug4xi' in keys2context:
        debug2xi = c2xi['debug4xi']     
    else:
        debug2xi = False

    
    # ---------------------------------------------------------------------------------------------
    # REASON
    # --------------------------------------------------------------------------------------------- 
    
    if debug2xi is True:
        print("(STEP 1A/33) OF XML_TRACE_REASON4XI - STARTED REASONING ", time4xi())   
        print("(STEP 1B/33) OF XML_TRACE_REASON4XI - SET C2XI TO: ", c2xi)
        print("(STEP 1C/33) OF XML_TRACE_REASON4XI - SET T2XI TO: ", t2xi)        
        # <print4xi.Print4Xi object at 0x000000000374EEB8>
        
    # ---------------------------------------------------------------------------------------------
    # 
    # --------------------------------------------------------------------------------------------- 
    if debug2xi is True:
        print("(STEP 2A/33) OF XML_TRACE_REASON4XI - TRYING TO SET KNOWLEDGEBASE ", time4xi())
    try:                    
        reasonKB4Xi = t2xi.reason()        
        print("(STEP 2B/33) OF XML_TRACE_REASON4XI - SET KNOWLEDGEBASE TO : ", reasonKB4Xi)
        len2kb= len(reasonKB4Xi)
        # 717 < 3191 = senseKB4XI
        print("(STEP 2C/33) OF XML_TRACE_REASON4XI - SET LEN2KB TO : ", len2kb)
        keys2kb = reasonKB4Xi.keys()            
        verb2xi = 'do nothing'
    except:
        print("(STEP 2Z/33) OF XML_TRACE_REASON4XI *** FAILED TO SET KNOWLEDGEBASE ", time4xi())
         
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------                                                     
    if debug2xi is True:
        print(33*("-"))
        print("(STEP 3A/33) OF XML_TRACE_REASON4XI - INPUT FROM PRINT4XI REASON-METHOD:")
        print(33*("-")) 
        try:                                               
            for key2kb in sorted(keys2kb):
                msg2xi = reasonKB4Xi[key2kb]               
                len2msg = len(msg2xi)
                print("")
                print(key2kb)
                print(21*(" "), msg2xi)
                # <verb4xi>activated</verb4xi><class4xi>ConstantConnection4Xi</class4xi><method4xi>__init__</method4xi><order4xi>#000000059</order4xi>
                #      <message4xi>{activated; constantconnection2xi-of-ConstantConnection4Xi-activated: 03:04:40 10/17/11 Pacific Daylight Time}</message4xi>    
        except:
            print("(STEP 3Z/33) OF XML_TRACE_REASON4XI *** FAILED TO SHOW INPUT FROM PRINT4XI REASON-METHOD ***")
  
    # ---------------------------------------------------------------------------------------------
    # TAILOR 
    # --------------------------------------------------------------------------------------------- 
    if debug2xi is True:
        print("(STEP 4A/33 XML_TRACE_REASON4XI - TRYING TO SET FILEPATH2XI ", time4xi())  
    try:
        if 'file_path4xi' in keys2context:
            filepath2xi = c2xi['file_path4xi']
            if debug2xi is True:
                print("(STEP 4B/33 XML_TRACE_REASON4XI - SET FILEPATH2XI TO: ", filepath2xi)    
        else:
            filepath2xi = '..\\..\\xml\\reason-default4xi.xml'
            if debug2xi is True:
                print("(STEP 4C/33 XML_TRACE_REASON4XI - SET FILEPATH2XI TO: ", filepath2xi) 
                            
        f2xi=open(filepath2xi, 'w')
    except:
        print("(STEP 4Z/33 XML_TRACE_REASON4XI *** FAILED TO SET SET FILEPATH2XI ", time4xi())  
        
    # ---------------------------------------------------------------------------------------------
    # 
    # --------------------------------------------------------------------------------------------- 
    if debug2xi is True:
        print("(STEP 5A/33 XML_TRACE_REASON4XI - OPENED XML FILE: ", filepath2xi)          
        print("(STEP 5B/33 XML_TRACE_REASON4XI - TRYING TO WRITE HEADER FOR XML FILE: ", filepath2xi)    
    try:            
        f2xi.write('<?xml version="1.0"?>\n')
        f2xi.write('<rdf:RDF\n')
        f2xi.write('   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"\n')
        f2xi.write('   xmlns:xsd="http://www.w3.org/2001/XMLSchema#"\n')
        f2xi.write('   xmlns:owl="http://www.w3.org/2002/07/owl#"\n')
        f2xi.write('   xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"\n')
        if debug2xi is True:
            print("(STEP 5C/33 XML_TRACE_REASON4XI - WROTE HEADER FOR XML FILE: ", filepath2xi) 
    except:
        print("(STEP 5Z/33 XML_TRACE_REASON4XI *** FAILED TO CREATE HEADER FOR XML FILE: ", filepath2xi) 
               
    # ---------------------------------------------------------------------------------------------
    # TAILOR  
    # ---------------------------------------------------------------------------------------------     
    try:
        if 'name_space4xi' in keys2context:
            namespace2xi = c2xi['name_space4xi'] 
        else:
            namespace2xi = '   xmlns="http://www.yourdragonxi.org/web/lib/owl/DefaultReason4Xi.owl#"\n'     
        f2xi.write(namespace2xi)
    except:
        pass
            
    # ---------------------------------------------------------------------------------------------
    # WRITE
    # --------------------------------------------------------------------------------------------- 
    try:    
        f2xi.write('   xmlns:p1="http://www.owl-ontologies.com/assert.owl#"\n')
    except:
        pass
            
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE  
    # ---------------------------------------------------------------------------------------------     
    try:
        if 'xml_base4xi' in keys2context: 
            xmlbase2xi = c2xi['xml_base4xi'] 
        else:
            xmlbase2xi = '   xml:base="http://www.yourdragonxi.org.com/web/lib/owl/reason-default4xi.owl">\n'
        f2xi.write(xmlbase2xi)
    except:
        pass 
        
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE  
    # ---------------------------------------------------------------------------------------------             
    try:
        if 'ontology_about4xi' in keys2context: 
            ontology_about2xi = c2xi['ontology_about4xi']
        else:
            ontology_about2xi = '   <owl:Ontology rdf:about="DefaultReason4Xi">\n'
        f2xi.write(ontology_about2xi)
    except:
        pass     

    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE  
    # ---------------------------------------------------------------------------------------------         
    try:
        if 'ontology_comment4xi' in keys2context:
            ontology_comment2xi = c2xi['ontology_comment4xi']
        else:
            ontology_comment2xi = '      <rdfs:comment xml:lang="en">reason-default4xi</rdfs:comment>\n'    
        f2xi.write(ontology_comment2xi)
    except:
        pass      

    # ---------------------------------------------------------------------------------------------
    # WRITE 
    # ---------------------------------------------------------------------------------------------             
    try:
        f2xi.write('      <owl:versionInfo xml:lang="en">Version ' + strftime("%a, %d %b %Y %H:%M:%S",localtime()) + '</owl:versionInfo>\n')
    except:
        pass  
            
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE  
    # ---------------------------------------------------------------------------------------------        
    try:
        if 'class0_id4xi' in keys2context:    
            class2xi = c2xi['class0_id4xi']    
        else:
            class2xi = '   <owl:Class rdf:ID="reasoned#000000">\n'
        f2xi.write(class2xi)
    except:
        pass      

    
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE
    # ---------------------------------------------------------------------------------------------         
    try:
        if 'operation_comment4xi' in keys2context:
            operation_comment2xi = c2xi['operation_comment4xi']
        else:
            operation_comment2xi = '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n'
        f2xi.write(operation_comment2xi)
    except:
        pass    
        
    # ---------------------------------------------------------------------------------------------
    # WRITE 
    # ---------------------------------------------------------------------------------------------             
    try:        
        f2xi.write('   </owl:Class>\n')
    except:
        pass  
            
    
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE
    # ---------------------------------------------------------------------------------------------     
    try:
        if 'object_property_rdf4xi' in keys2context:
            object_property2xi = c2xi['object_property_rdf4xi']
        else:
            object_property2xi = '   <owl:ObjectProperty rdf:ID="reasoning#0">\n'

        f2xi.write(object_property2xi)
    except:
        pass 
    
    # ---------------------------------------------------------------------------------------------
    # TAILORED WRITE
    # ---------------------------------------------------------------------------------------------         
    try:
        if 'object_property_comment4xi' in keys2context:
            object_property_comment2xi = c2xi['object_property_comment4xi']
        else:
            object_property_comment2xi = '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'    
        f2xi.write(object_property_comment2xi)
    except:
        pass 
    # ---------------------------------------------------------------------------------------------
    # WRITE 
    # ---------------------------------------------------------------------------------------------             
    try:            
        f2xi.write('   </owl:ObjectProperty>\n')
    except:
        pass 
    # ---------------------------------------------------------------------------------------------
    # 
    # --------------------------------------------------------------------------------------------- 
    try:                     
        orderIRI2xi = "#0"
        classIRI2xi = "to-be-solved-class"
        methodIRI2xi = "to-be-solved-method"
            
        classPropertyID2xi = 1
        classComment2xi = "Comment of Class "
        objectPropertID2Xi = 1
        objectPropertComment2xi = "Comment of Object Property "     
    except:
        pass     
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------   
    try:
        for key2kb in sorted(keys2kb):
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------            
            while 1:
                try:                                                                              
                    start_index2verb = str.find(key2kb,'<verb4xi>')                 # 
                    end_index2verb = str.find(key2kb,'</verb4xi>')
                         
                    if (end_index2verb == -1) or (start_index2verb == -1):
                        print("(STEP 6Z1/33) OF XML_TRACE_REASON4XI *** FAILED TO FIND VERB-TAG INSIDE THE KEY OF REASONED DICTIONARY - KEY2KB ", key2kb) 
                        break
                    else:
                        verbIRI2xi = key2kb[start_index2verb+9:end_index2verb]      # 
                        break
                except:
                    break                           
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------             
            while 1:
                try:                                                                               
                    start_index2order = str.find(key2kb,'<order4xi>')               # 
                    end_index2order = str.find(key2kb,'</order4xi>')
                         
                    if (end_index2order == -1) or (start_index2order == -1):
                        print("(STEP 6Z2/33) OF XML_TRACE_REASON4XI *** FAILED TO FIND ORDER NUMBER INSIDE KEY2KB ", key2kb) 
                        break
                    else:
                        orderIRI2xi = key2kb[start_index2order+10:end_index2order]   #
                        break
                except:
                    break                           
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------  
            while 1:                                                                              
                try:
                    start_index2class = str.find(key2kb,'<class4xi>')                # 
                    end_index2class = str.find(key2kb,'</class4xi>')
                         
                    if (end_index2class == -1) or (start_index2class == -1):
                        print("(STEP 6Z3/33) OF XML_TRACE_REASON4XI *** FAILED TO FIND CLASS4XI TAG INSIDE KEY2KB ", key2kb) 
                        break
                    else:
                        classIRI2xi = key2kb[start_index2class:end_index2class+11 ]  # 
                        break
                except:
                    break                       
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------                                             
            while 1:                                                                              
                try:
                    start_index2method = str.find(key2kb,'<method4xi>')              # 
                    end_index2method = str.find(key2kb,'</method4xi>')
                         
                    if (end_index2method == -1) or (start_index2method == -1):
                        print("(STEP 6Z4/33) OF XML_TRACE_REASON4XI *** FAILED TO FIND CLASS4XI TAG INSIDE KEY2KB ", key2kb) 
                        break
                    else:
                        methodIRI2xi = key2kb[start_index2method:end_index2method+12] # 
                        break 
                except:
                    break
                                                 
            # -----------------------------------------------------------------------------------------
            # TAILORED WRITE
            # -----------------------------------------------------------------------------------------        
            try:
                f2xi.write('   <owl:Class rdf:ID="' + verbIRI2xi + orderIRI2xi + '">\n')           # 
            except:
                pass  
     
    
            # -----------------------------------------------------------------------------------------
            # TAILORED WRITE - MOVED FILTERING < and > TAGS IN MESSAGES TO PRINT4XI.PY
            # -----------------------------------------------------------------------------------------        
            try:
                msgIRI2xi = reasonKB4Xi[key2kb]                    #                       
          
                                        
                if debug2xi is True:
                    print("xml_trace_reason4xi: writing: ", classIRI2xi + methodIRI2xi + msgIRI2xi)             
                f2xi.write('      <rdfs:comment xml:lang="en">' + classIRI2xi + methodIRI2xi + msgIRI2xi + '</rdfs:comment>\n') 
                
                f2xi.write('   </owl:Class>\n')
            except:
                pass 
             
    except:
        pass                         
    # ---------------------------------------------------------------------------------------------
    # END OF ONTOLOGY, RDF AND COPYRIGHT
    # ---------------------------------------------------------------------------------------------     
    if debug2xi is True:
        print(33*("-"))
        print("xml_trace_reason4xi: create end for XML file")     
        print("(STEP 8A/33) OF XML_TRACE_REASON4XI - TRYING TO CREATE END FOR XML FILE ", time4xi()) 
        print(33*("-"))          
    try:            
        f2xi.write('   </owl:Ontology>\n')
        f2xi.write('</rdf:RDF>\n')
        f2xi.write('<!-- Copyright Small & Smart Inc. All rights reserved. -->\n')
        if debug2xi is True:
            print("(STEP 8B/33) OF XML_TRACE_REASON4XI - CREATED END FOR XML FILE ", time4xi())
    except:
        print("(STEP 8Z/33) OF XML_TRACE_REASON4XI *** FAILED TO CREATE END FOR XML FILE ", time4xi()) 
              
    # ---------------------------------------------------------------------------------------------
    # CLOSE
    # ---------------------------------------------------------------------------------------------                    
    try:    
        f2xi.close()        
    except:
        pass  
    # ---------------------------------------------------------------------------------------------
    # RETURN
    # ---------------------------------------------------------------------------------------------       
    if debug2xi is True:
        print(33*("-"))
        print("(STEP 33/33) OF XML_TRACE_REASON4XI - CLOSED XML FILE ", time4xi())     
        print(33*("-"))
            

#</program4xi>
         
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   reason*4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of xml_trace_reason4xi.py                            
# ------------------------------------------------------------------------------------------------- 
#"
#/>    
